## cloud-init 23.2.2

=== debian/changelog ===
cloud-init (23.2.2-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.2.2.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2.2/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2028562, #2028784)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 01 Aug 2023 14:18:47 +0200

cloud-init (23.2.1-0ubuntu0~20.04.2) focal; urgency=medium

  * d/apport-general-hook: correct type hints on Dict for py3.8
    (LP: #2025376)

 -- Chad Smith <chad.smith@canonical.com>  Thu, 29 Jun 2023 09:41:13 -0600

cloud-init (23.2.1-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.2.1. (LP: #2025180).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2.1/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Wed, 28 Jun 2023 16:14:16 -0600

cloud-init (23.2-0ubuntu0~20.04.1) focal; urgency=medium

  * d/control: Remove pep8 dependency. It is no longer used
  * d/patches/netplan99-cannot-use-default.patch:
    - Retain routes' definitions compatible with netplan 0.99 (Fixes: #4133)
  * d/apport-general-hook.py: Add general apport hook to append cloud type,
    image and instance size information to bug reports (LP: #1724623)
  * d/cloud-init.preinst: Oracle to remove vestigial /etc/cloud.cloud.cfg.d/
    99-disable-network-config.cfg because system config is now honored before
    datasource config (LP: #1956788)
  * d/cloud-init.preinst: Clean up vestigial
    /etc/cloud/cloud.cfg.d/99-disable-network-activation.cfg on GCE instances
    after fix in upstream google-guest-agent.
  * Refresh patches against upstream/main:
    - d/p/expire-on-hashed-users.patch
    - d/p/retain-netplan-world-readable.patch
  * Upstream snapshot based on 23.2. (LP: #2023110).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Tue, 06 Jun 2023 16:07:04 -0600

cloud-init (23.1.2-0ubuntu0~20.04.2) focal; urgency=medium

  * d/patches/netplan99-cannot-use-default.patch:
    - Retain routes' definitions compatible with netplan 0.99 (Fixes: #4133)

 -- James Falcon <james.falcon@canonical.com>  Fri, 19 May 2023 12:57:02 -0500

cloud-init (23.1.2-0ubuntu0~20.04.1) focal; urgency=medium

  * SECURITY UPDATE: Make user/vendor data sensitive and remove log permissions
    Because user data and vendor data may contain sensitive information,
    this commit ensures that any user data or vendor data written to
    instance-data.json gets redacted and is only available to root user.

    Also, modify the permissions of cloud-init.log to be 640, so that
    sensitive data leaked to the log isn't world readable.
    Additionally, remove the logging of user data and vendor data to
    cloud-init.log from the Vultr datasource.

    This is based on upstream snapshot of 23.1.2 [(LP: #2013967)]

    - d/cloud-init.postinst: postinst fixes for LP: #2013967
      Redact sensitive keys from world-readable instance-data.json on upgrade.
      Set perms 640 for /var/log/cloud-init.log on pkg upgrade.
      Redact sensitive Vultr messages from /var/log/cloud-init.log
    - (CVE-2023-1786)

 -- James Falcon <james.falcon@canonical.com>  Fri, 21 Apr 2023 14:28:19 -0500

cloud-init (23.1.1-0ubuntu0~20.04.1) focal; urgency=medium

  * d/patches/retain-netplan-world-readable.patch:
    - Retain original world-readable perms of /etc/netplan/50-cloud-init.yaml.
      Lunar made the config root read-only.
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 23.1.1. (LP: #2008230).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.1.1/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Fri, 03 Mar 2023 09:48:54 +0100

cloud-init (22.4.2-0ubuntu0~20.04.2) focal; urgency=medium

  * d/compat & d/control: revert bump debhelper-comat to v10. Avoid
    service restarts across package upgrade (LP: #1999159)
    - d/compat: replaced with compat level 9
    - d/control: Build-Depends: revert to debhelper >= 9

 -- Chad Smith <chad.smith@canonical.com>  Thu, 08 Dec 2022 09:45:11 -0700

cloud-init (22.4.2-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 22.4.2 upstream release. (LP: #1996645)
    - List of changes from upstream can be found at
      https://raw.githubusercontent.com/canonical/cloud-init/22.4.2/ChangeLog
    - Includes (LP: #1997559, #1844191) not present in 22.4.0.

 -- James Falcon <james.falcon@canonical.com>  Mon, 28 Nov 2022 10:48:49 -0600

cloud-init (22.4-0ubuntu0~20.04.1) focal; urgency=medium

  * d/control: drop python3-httpretty from Build-Depends
  * d/cloud-init.templates: Add NWCS to datasource list
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 22.4 upstream release. (LP: #1996645)
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/22.4/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 15 Nov 2022 16:17:27 -0600

cloud-init (22.3.4-0ubuntu1~20.04.1) focal; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.4 (LP: #1986703)
    + Fix Oracle DS primary interface when using IMDS (#1757)
      (LP: #1989686)

 -- Brett Holman <brett.holman@canonical.com>  Mon, 03 Oct 2022 10:57:17 -0600

cloud-init (22.3.3-0ubuntu1~20.04.1) focal; urgency=medium

  * New upstream bugfix release. (LP: #1987318)
    + Release 22.3.3
    + Fix Oracle DS not setting subnet when using IMDS (#1735)
    + azure: define new attribute for pre-22.3 pickles (#1725)
    + sources/azure: ensure instance id is always correct (#1727)
      [Chris Patterson]

 -- Brett Holman <brett.holman@canonical.com>  Wed, 21 Sep 2022 14:16:25 -0600



=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 9.20160709),
               dh-python,
               iproute2,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-netifaces,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses
XS-Python-Version: all
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.4.1
Rules-Requires-Root: no

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         isc-dhcp-client,
         iproute2,
         netplan.io,
         procps,
         python3,
         python3-debconf,
         python3-netifaces,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, software-properties-common
Suggests: openssh-server, ssh-import-id
XB-Python-Version: ${python:Versions}
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.

## cloud-init 23.3

=== debian/changelog ===
cloud-init (23.3-0ubuntu1) mantic; urgency=medium

  * d/po/templates.pot: refresh with debconf-updatepo
  * d/cloud-init.templates: enable Akamai by default.
    Add Akamai to the default templates to allow datasource discovery.
  * Upstream snapshot based on 23.3.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2030788, #1980150, #1884127)
      (LP: #1998539)

 -- Chad Smith <chad.smith@canonical.com>  Mon, 28 Aug 2023 12:33:17 -0600

cloud-init (23.3~4ga31370af-0ubuntu1) mantic; urgency=medium

  * Upstream snapshot based on upstream/main at a31370af.
    - Bugs fixed in this snapshot: (LP: #1923363, #2028562, #2028784)
  * d/cloud-init.maintscript: Remove the unused hook-network-manager
    conffile. (LP: #2027861)
  * d/control: Add python3-passlib as needed for testing

 -- James Falcon <james.falcon@canonical.com>  Mon, 31 Jul 2023 11:38:42 -0500

cloud-init (23.3~3gebd7b2b6-0ubuntu1) mantic; urgency=medium

  * Upstream snapshot based on upstream/main at ebd7b2b6.

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 18 Jul 2023 17:37:07 +0200

cloud-init (23.3~2gcf474da7-0ubuntu1) mantic; urgency=medium

  * Upstream snapshot based on upstream/main at cf474da7.
    - Bugs fixed in this snapshot: (LP: #2013403)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 11 Jul 2023 10:22:04 +0200

cloud-init (23.3~1ge5a617fe-0ubuntu1) mantic; urgency=medium

  * Upstream snapshot based on upstream/main at e5a617fe.
    - Bugs fixed in this snapshot: (LP: #2025180, #2025180, #1999952)
      (LP: #1798055)

 -- Chad Smith <chad.smith@canonical.com>  Wed, 28 Jun 2023 09:57:55 -0600

cloud-init (23.2-0ubuntu1) mantic; urgency=medium

  * d/control: Remove pep8 dependency. It is no longer used.
  * Upstream snapshot based on 23.2.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2011783, #2008888, #1854594, #2016350)
      (LP: #1881925, #2013967, #2011291)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Wed, 24 May 2023 19:06:03 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Homepage: https://cloud-init.io/
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Build-Depends: debhelper (>= 9.20160709),
+Build-Depends: debhelper-compat (= 13),
                dh-python,
                iproute2,
                po-debconf,
@@ -22,11 +22,11 @@
                python3-serial,
                python3-setuptools,
                python3-yaml,
-               python3-responses
-XS-Python-Version: all
+               python3-responses,
+               python3-passlib
 Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
 Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 
 Package: cloud-init
@@ -43,9 +43,8 @@
          python3-serial,
          ${misc:Depends},
          ${python3:Depends}
-Recommends: eatmydata, gdisk, software-properties-common
+Recommends: eatmydata, gdisk, gnupg, software-properties-common
 Suggests: openssh-server, ssh-import-id
-XB-Python-Version: ${python:Versions}
 Description: initialization and customization tool for cloud instances
  Cloud-init is the industry standard multi-distribution method for
  cross-platform cloud instance initialization. It is supported across all major

## cloud-init 23.3.1

=== debian/changelog ===
cloud-init (23.3.1-0ubuntu2) mantic; urgency=medium

  * New upstream bug fix release based on 23.3.1.
    + Install missing dependencies in apt module if required for minimal images.
      - d/p/cpick-0d9f149a-Pytestify-apt-config-test-modules-4424
      - d/p/cpick-5023e9f9-Refactor-test_apt_source_v1.py-to-use-pytest-4427
      - d/p/cpick-e9cdd7e3-Install-gnupg-if-gpg-not-found-4431
      - d/p/cpick-015543d3-apt-install-software-properties-common-when-absent-but

 -- Brett Holman <brett.holman@canonical.com>  Thu, 28 Sep 2023 12:00:23 -0500

cloud-init (23.3.1-0ubuntu1) mantic; urgency=medium

  * New upstream bug fix release based on 23.3.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.1/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2034273)

 -- Chad Smith <chad.smith@canonical.com>  Tue, 05 Sep 2023 17:03:59 -0600

## cloud-init 23.3.3

=== debian/changelog ===
cloud-init (23.3.3-0ubuntu0~22.04.1) jammy; urgency=medium

  * Upstream snapshot based on 23.3.3. (LP: #2040291).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.3/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 24 Oct 2023 10:50:55 -0500

cloud-init (23.3.2-0ubuntu0~22.04.1) jammy; urgency=medium

  * d/p/do-not-block-user-login.patch:
    - Revert behavior, allow user login after cloud-init stage (LP: #2039505)
  * Upstream snapshot based on 23.3.2. (LP: #2039453).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.2/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Mon, 17 Oct 2023 15:53:22 -0600

cloud-init (23.3.1-0ubuntu1~22.04.1) jammy; urgency=medium

  * d/cloud-init.maintscript: Remove the unused hook-network-manager
    conffile. (LP: #2027861)
  * d/patches/retain-old-groups.patch:
    - Retain original groups in cloud.cfg.tmpl
  * Upstream snapshot based on upstream/main at 5509b790.
  * d/control: Add python3-passlib as needed for testing
  * d/cloud-init.templates: enable Akamai by default.
    Add Akamai to the default templates to allow datasource discovery.
  * d/po/templates.pot: refresh with debconf-updatepo
  * Upstream snapshot based on 23.3.1. (LP: #2033310).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.1/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Wed, 06 Sep 2023 12:09:54 -0500

cloud-init (23.2.2-0ubuntu0~22.04.1) jammy; urgency=medium

  * Upstream snapshot based on 23.2.2.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2.2/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2028562, #2028784)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 01 Aug 2023 14:16:07 +0200

cloud-init (23.2.1-0ubuntu0~22.04.1) jammy; urgency=medium

  * Upstream snapshot based on 23.2.1. (LP: #2025180).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2.1/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Wed, 28 Jun 2023 15:46:07 -0600

cloud-init (23.2-0ubuntu0~22.04.1) jammy; urgency=medium

  * d/control: Remove pep8 dependency. It is no longer used.
  * d/apport-general-hook.py: Add general apport hook to append cloud type,
    image and instance size information to bug reports (LP: #1724623)
  * d/cloud-init.preinst: Oracle to remove vestigial /etc/cloud.cloud.cfg.d/
    99-disable-network-config.cfg because system config is now honored before
    datasource config (LP: #1956788)
  * d/cloud-init.preinst: Clean up vestigial
    /etc/cloud/cloud.cfg.d/99-disable-network-activation.cfg on GCE instances
    after fix in upstream google-guest-agent.
  * Refresh patches against upstream/main
    - d/p/expire-on-hashed-users.patch
    - d/p/retain-netplan-world-readable.patch
  * Upstream snapshot based on 23.2. (LP: #2023110).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.2/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Tue, 06 Jun 2023 16:09:06 -0600

cloud-init (23.1.2-0ubuntu0~22.04.1) jammy; urgency=medium

  * SECURITY UPDATE: Make user/vendor data sensitive and remove log permissions
    Because user data and vendor data may contain sensitive information,
    this commit ensures that any user data or vendor data written to
    instance-data.json gets redacted and is only available to root user.

    Also, modify the permissions of cloud-init.log to be 640, so that
    sensitive data leaked to the log isn't world readable.
    Additionally, remove the logging of user data and vendor data to
    cloud-init.log from the Vultr datasource.

    This is based on upstream snapshot of 23.1.2 [(LP: #2013967)]

    - d/cloud-init.postinst: postinst fixes for LP: #2013967
      Redact sensitive keys from world-readable instance-data.json on upgrade.
      Set perms 640 for /var/log/cloud-init.log on pkg upgrade.
      Redact sensitive Vultr messages from /var/log/cloud-init.log
    - (CVE-2023-1786)

 -- James Falcon <james.falcon@canonical.com>  Thu, 20 Apr 2023 20:37:40 -0500

cloud-init (23.1.1-0ubuntu0~22.04.1) jammy; urgency=medium

  * d/patches/retain-netplan-world-readable.patch:
    - Retain original world-readable perms of /etc/netplan/50-cloud-init.yaml.
      Lunar made the config root read-only.
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 23.1.1. (LP: #2008230).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.1.1/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Fri, 03 Mar 2023 10:06:20 +0100

cloud-init (22.4.2-0ubuntu0~22.04.1) jammy; urgency=medium

  * Upstream snapshot based on 22.4.2 upstream release. (LP: #1996645)
    - List of changes from upstream can be found at
      https://raw.githubusercontent.com/canonical/cloud-init/22.4.2/ChangeLog
    - Includes (LP: #1997559, #1844191) not present in 22.4.0.

 -- James Falcon <james.falcon@canonical.com>  Mon, 28 Nov 2022 10:32:24 -0600

cloud-init (22.4-0ubuntu0~22.04.1) jammy; urgency=medium

  * d/control: drop python3-httpretty from Build-Depends
  * d/cloud-init.templates: Add NWCS to datasource list
  * refresh patches:
    + debian/patches/expire-on-hashed-users.patch
  * Upstream snapshot based on 22.4 upstream release. (LP: #1996645)
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/22.4/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 15 Nov 2022 16:13:00 -0600

=== debian/control ===
--- 
+++ 
@@ -24,6 +24,7 @@
                python3-yaml,
                python3-responses,
                python3-passlib
+XS-Python-Version: all
 Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
 Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
 Standards-Version: 4.5.0
@@ -45,6 +46,7 @@
          ${python3:Depends}
 Recommends: eatmydata, gdisk, gnupg, software-properties-common
 Suggests: openssh-server, ssh-import-id
+XB-Python-Version: ${python:Versions}
 Description: initialization and customization tool for cloud instances
  Cloud-init is the industry standard multi-distribution method for
  cross-platform cloud instance initialization. It is supported across all major

## cloud-init 23.4

=== Makefile ===
CWD=$(shell pwd)
VARIANT ?= ubuntu

YAML_FILES=$(shell find cloudinit tests tools -name "*.yaml" -type f )
YAML_FILES+=$(shell find doc/examples -name "cloud-config*.txt" -type f )

PYTHON ?= python3

NUM_ITER ?= 100

distro ?= redhat

READ_VERSION=$(shell $(PYTHON) $(CWD)/tools/read-version || echo read-version-failed)
CODE_VERSION=$(shell $(PYTHON) -c "from cloudinit import version; print(version.version_string())")
GENERATOR_F=./systemd/cloud-init-generator
DS_IDENTIFY=./tools/ds-identify
BENCHMARK=./tools/benchmark.sh


all: check

check: check_version test yaml

style-check: lint

lint:
	@$(CWD)/tools/run-lint

unittest: clean_pyc
	$(PYTHON) -m pytest -v tests/unittests cloudinit

render-template:
	$(PYTHON) ./tools/render-template --variant=$(VARIANT) $(FILE) $(subst .tmpl,,$(FILE))

# from systemd-generator(7) regarding generators:
# "We do recommend C code however, since generators are executed
# synchronously and hence delay the entire boot if they are slow."
#
# Our generator is a shell script. Make it easy to measure the
# generator. This should be monitored for performance regressions
benchmark-generator: FILE=$(GENERATOR_F).tmpl
benchmark-generator: VARIANT="benchmark"
benchmark-generator: export ITER=$(NUM_ITER)
benchmark-generator: render-template
	$(BENCHMARK) $(GENERATOR_F)

benchmark-ds-identify: export ITER=$(NUM_ITER)
benchmark-ds-identify:
	$(BENCHMARK) $(DS_IDENTIFY)

ci-deps-ubuntu:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro ubuntu --test-distro

ci-deps-centos:
	@$(PYTHON) $(CWD)/tools/read-dependencies --distro centos --test-distro

test: unittest

check_version:
	@if [ "$(READ_VERSION)" != "$(CODE_VERSION)" ]; then \
		echo "Error: read-version version '$(READ_VERSION)'" \
			"not equal to code version '$(CODE_VERSION)'"; \
		exit 2; \
	else true; fi

config/cloud.cfg:
	$(PYTHON) ./tools/render-template --is-yaml config/cloud.cfg.tmpl config/cloud.cfg

clean_pyc:
	@find . -type f -name "*.pyc" -delete
	@find . -type d -name __pycache__ -delete

clean_pytest:
	rm -rf .cache htmlcov

clean_packaging:
	rm -rf srpm cloud_init.egg-info/ \
		cloud-init-*.tar.gz \
		cloud-init-*.tar.gz.asc \
		cloud-init.dsc \
		cloud-init_*.build \
		cloud-init_*.buildinfo \
		cloud-init_*.changes \
		cloud-init_*.deb \
		cloud-init_*.dsc \
		cloud-init_*.orig.tar.gz \
		cloud-init_*.tar.xz \
		cloud-init_*.upload

clean_release:
	rm -rf new-upstream-changes.txt commit.msg

clean: clean_pyc clean_pytest clean_packaging clean_release
	rm -rf doc/rtd_html .tox .coverage tags $(GENERATOR_F)

yaml:
	@$(PYTHON) $(CWD)/tools/validate-yaml.py $(YAML_FILES)

rpm:
	$(PYTHON) ./packages/brpm --distro=$(distro)

srpm:
	$(PYTHON) ./packages/brpm --srpm --distro=$(distro)

deb:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }

	$(PYTHON) ./packages/bddeb

deb-src:
	@which debuild || \
		{ echo "Missing devscripts dependency. Install with:"; \
			echo sudo apt-get install devscripts; exit 1; }
	$(PYTHON) ./packages/bddeb -S -d

doc:
	tox -e doc

fmt:
	tox -e do_format && tox -e check_format

fmt-tip:
	tox -e do_format_tip && tox -e check_format_tip

# Spell check && filter false positives
_CHECK_SPELLING := find doc -type f -exec spellintian {} + | \
       grep -v -e 'doc/rtd/topics/cli.rst: modules modules' \
               -e 'doc/examples/cloud-config-mcollective.txt: WARNING WARNING' \
               -e 'doc/examples/cloud-config-power-state.txt: Bye Bye' \
               -e 'doc/examples/cloud-config.txt: Bye Bye' \
               -e 'doc/rtd/topics/cli.rst: DOCS DOCS' \
               -e 'doc/summit/2023_summit_shared_notes.md: Moustafa Moustafa' \
               -e 'dependant'


# For CI we require a failing return code when spellintian finds spelling errors
check_spelling:
	@! $(_CHECK_SPELLING)

# Manipulate the output of spellintian into a valid "sed" command which is run
# to fix the error
#
# Example spellintian output:
#
# doc/examples/kernel-cmdline.txt: everthing -> everything
#
# The "fix_spelling" target manipulates the above output into the following command
# and runs that command.
#
# sed -i "s/everthing/everything/g" doc/examples/kernel-cmdline.txt
#
# awk notes:
#
# -F ': | -> ' means use the strings ": " or " -> " as field delimeters
# \046 is octal for double quote
# $$2 will contain the second field, ($ must be escaped because this is in a Makefile)
#
# Limitation: duplicate words with newline between them are not automatically fixed
fix_spelling:
	@$(_CHECK_SPELLING) | \
		sed 's/ (duplicate word)//g' | \
		awk -F ': | -> ' '{printf "sed -i \047s/%s/%s/g\047 %s\n", $$2, $$3, $$1}' | \
		sh

.PHONY: all check test lint clean rpm srpm deb deb-src yaml
.PHONY: check_version clean_pyc
.PHONY: unittest style-check fix_spelling render-template benchmark-generator
.PHONY: clean_pytest clean_packaging check_spelling clean_release doc

=== debian/changelog ===
cloud-init (23.4-0ubuntu1~23.10.1) mantic; urgency=medium

  * d/p/status-do-not-remove-duplicated-data.patch:
    - Revert behavior downstream, leave duplicate data
  * d/control: add python3-apt as Recommends to read APT config from apt_pkg
  * Upstream snapshot based on 23.4. (LP: #2045582).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 05 Dec 2023 14:17:28 +0100

cloud-init (23.3.3-0ubuntu0~23.10.1) mantic; urgency=medium

  * Upstream snapshot based on 23.3.3. (LP: #2040291).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.3/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 24 Oct 2023 10:43:22 -0500

cloud-init (23.3.2-0ubuntu0~23.10.1) mantic; urgency=medium

  [ Brett Holman ]
  * d/p/do-not-block-user-login.patch:
    - Revert behavior, allow user login after cloud-init stage (LP: #2039505)
  * cherry-pick 2ab1f340: fix(cc_apt_configure): avoid unneeded call to
    apt-get update (LP: #2039621)
  * Upstream snapshot based on 23.3.2. (LP: #2039453).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.2/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 17 Oct 2023 17:12:09 -0500

## cloud-init 23.4.4

=== debian/changelog ===
cloud-init (23.4.4-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.4.4. (LP: #2055081).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4.4/ChangeLog

 -- Chad Smith <chad.smith@canonical.com>  Tue, 27 Feb 2024 08:13:27 -0700

cloud-init (23.4.3-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.4.3. (LP: #2046483).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4.3/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Fri, 02 Feb 2024 16:00:45 -0600

cloud-init (23.4.2-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.4.2. (LP: #2045582).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4.2/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2051147)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Wed, 24 Jan 2024 19:19:59 +0100

cloud-init (23.4.1-0ubuntu1~20.04.2) focal; urgency=medium

  * d/p/status-retain-recoverable-error-exit-code.patch:
    Retain exit code in cloud-init status for recoverable errors.
    (LP: #2048522).

 -- Alberto Contreras <alberto.contreras@canonical.com>  Mon, 08 Jan 2024 17:12:57 +0100

cloud-init (23.4.1-0ubuntu1~20.04.1) focal; urgency=medium

  * d/p/retain-apt-pre-deb822.patch:
    - Disable apt source list generation with DEB822 style
  * refresh patches:
    - d/p/status-do-not-remove-duplicated-data.patch
  * d/changelog: amend 23.4-0 refresh patches entry
  * Upstream snapshot based on 23.4.1. (LP: #2045582).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4.1/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Fri, 15 Dec 2023 13:27:06 +0100

cloud-init (23.4-0ubuntu1~20.04.1) focal; urgency=medium

  * d/p/status-do-not-remove-duplicated-data.patch:
    - Revert behavior downstream, leave duplicate data
  * d/control: add python3-apt as Recommends to read APT config from apt_pkg
  * refresh patches:
    - d/p/do-not-block-user-login.patch
    - d/p/netplan99-cannot-use-default.patch
  * Upstream snapshot based on 23.4. (LP: #2045582).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Tue, 05 Dec 2023 14:00:12 +0100

cloud-init (23.3.3-0ubuntu0~20.04.1) focal; urgency=medium

  * Upstream snapshot based on 23.3.3. (LP: #2040291).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.3/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Tue, 24 Oct 2023 10:59:56 -0500

cloud-init (23.3.2-0ubuntu0~20.04.1) focal; urgency=medium

  * d/p/do-not-block-user-login.patch:
    - Revert behavior, allow user login after cloud-init stage (LP: #2039505)
  * Upstream snapshot based on 23.3.2. (LP: #2039453).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.2/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Mon, 17 Oct 2023 15:51:22 -0600

cloud-init (23.3.1-0ubuntu1~20.04.1) focal; urgency=medium

  * Upstream snapshot based on upstream/main at ee9078a7.
  * d/cloud-init.maintscript: Remove the unused hook-network-manager
    conffile. (LP: #2027861)
  * d/patches/retain-old-groups.patch:
    - Retain original groups in cloud.cfg.tmpl
  * d/control: Add python3-passlib as needed for testing
  * d/cloud-init.templates: enable Akamai by default.
    Add Akamai to the default templates to allow datasource discovery.
  * d/po/templates.pot: refresh with debconf-updatepo
  * Upstream snapshot based on 23.3.1. (LP: #2033310).
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.3.1/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Wed, 06 Sep 2023 12:11:17 -0500

## cloud-init 24.1~3gb729a4c4

=== debian/changelog ===
cloud-init (24.1~3gb729a4c4-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on upstream/main at b729a4c4.

 -- Chad Smith <chad.smith@canonical.com>  Tue, 09 Jan 2024 15:38:50 -0700

cloud-init (24.1~2gb6a1c635-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on upstream/main at b6a1c635.
    - Bugs fixed in this snapshot: (LP: #2045086, #1951639)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Thu, 04 Jan 2024 10:16:55 +0100

cloud-init (24.1~1g1003d438-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on upstream/main at 1003d438.
    - Bugs fixed in this snapshot: (LP: #2040325)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Fri, 15 Dec 2023 11:34:16 +0100

cloud-init (23.4-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on 23.4.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/23.4/ChangeLog

 -- Alberto Contreras <alberto.contreras@canonical.com>  Mon, 04 Dec 2023 18:51:25 +0100

cloud-init (23.4~3g0cb0b80f-0ubuntu1) noble; urgency=medium

  * d/p/do-not-block-user-login.patch:
    - Revert behavior, allow user login after cloud-init stage (LP: #2039505)
  * d/control: add python3-apt as Recommends to read APT config from apt_pkg
  * drop the following cherry-picks now included:
    + d/p/cpick-0d9f149a-Pytestify-apt-config-test-modules-4424
    + d/p/cpick-5023e9f9-Refactor-test_apt_source_v1.py-to-use-pytest-4427
    + d/p/cpick-e9cdd7e3-Install-gnupg-if-gpg-not-found-4431
    + d/p/cpick-015543d3-apt-install-software-properties-common-when-absent-but
  * Upstream snapshot based on upstream/main at 0cb0b80f.
    - Bugs fixed in this snapshot: (LP: #2034273, #2030729)
      (LP: #2038945, #2039453)

 -- Chad Smith <chad.smith@canonical.com>  Wed, 08 Nov 2023 22:24:09 -0700

## cloud-init 24.1.1

=== debian/changelog ===
cloud-init (24.1.1-1) unstable; urgency=medium

  [ Nick Brown ]
  * Add logrotate config (Closes: #926424)

  [ Debian Janitor ]
  * Update lintian override info format in d/cloud-init.lintian-overrides
    on line 3-7.
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Bump debhelper from old 10 to 13.
    + Drop check for DEB_BUILD_OPTIONS containing "nocheck", since
      debhelper now does this.
    + Replace --no-restart-on-upgrade with --no-stop-on-upgrade.
    + Use dh_installsystemd rather than deprecated dh_systemd_start.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Ross Vandegrift ]
  * d/control: Conflict with firewalld (Closes: #1025618)
    cloud-init and firewalld's systemd units jointly have startup cycles.
    Currently, they cannot be eliminated without breaking features of one
    or the other.
  * d/control: drop obsolete Depends on lsb-base

  [ Noah Meyerhans ]
  * Fix debian/rules clean fails from git repo
    This may not be strictly correct from a pybuild perspective, but it
    avoids the need to call `setup.py` from the clean recipe.
    (Closes: #955620)

  [ Ross Vandegrift ]
  * New upstream version 24.1 (Closes: #1057548)
  * d/p/0001-config-Support-APT-automated-mirror-selection.patch: refresh
  * d/p/0006-Disable-two-failing-WSL-unittests.patch: disable failing WSL tests

  [ Noah Meyerhans ]
  * New upstream version 24.1.1
  * Drop patch 0006-Disable-two-failing-WSL-unittests.patch

 -- Noah Meyerhans <noahm@debian.org>  Mon, 11 Mar 2024 20:00:23 -0700

cloud-init (23.3.1-1) unstable; urgency=medium

  * New upstream version 23.3.1
  * Refresh patches
  * add python3-passlib to build-deps

 -- Noah Meyerhans <noahm@debian.org>  Sun, 10 Sep 2023 19:33:52 -0700

cloud-init (23.2.1-1) unstable; urgency=medium

  * New upstream version 23.2.1

 -- Noah Meyerhans <noahm@debian.org>  Wed, 28 Jun 2023 13:24:31 -0700

cloud-init (23.2-1) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Drop unused build dependencies (Closes: #1026813)

  [ Noah Meyerhans ]
  * New upstream version 23.2 (Closes: #1008039, #1005318, #999400)
  * Refresh patches
  * drop special handling of files that no longer exist upstream
  * drop dependency on obsolete lsb-base package

 -- Noah Meyerhans <noahm@debian.org>  Wed, 14 Jun 2023 09:42:18 -0700

=== debian/control ===
Source: cloud-init
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders:
 Bastian Blank <waldi@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Noah Meyerhans <noahm@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 iproute2,
 po-debconf,
 procps <!nocheck>,
 pylint,
 python3-all,
 python3-pep8,
 python3-setuptools,
Build-Depends-Indep:
 python3-configobj,
 python3-httpretty (>= 0.9.5),
 python3-jinja2,
 python3-jsonpatch,
 python3-jsonschema,
 python3-mock,
 python3-netifaces,
 python3-oauthlib,
 python3-passlib,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-mock,
 python3-requests,
 python3-responses,
 python3-serial,
 python3-yaml,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-init
Vcs-Git: https://salsa.debian.org/cloud-team/cloud-init.git
Homepage: https://launchpad.net/cloud-init

Package: cloud-init
Architecture: all
Conflicts: firewalld
Depends:
 eject,
 fdisk | util-linux (<< 2.29.2-3~),
 gdisk,
 isc-dhcp-client,
 locales,
 lsb-release,
 procps,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cloud-guest-utils,
 eatmydata,
 sudo,
Suggests:
 btrfs-progs,
 e2fsprogs,
 xfsprogs,
Description: initialization system for infrastructure cloud instances
 Cloud-init provides a framework and tool to configure and customize virtual
 machine instances for Infrastructure-as-a-Service (IaaS) clouds platforms. It
 can for example set a default locale and hostname, generate SSH private host
 keys, install SSH public keys for logging into a default account, set up
 ephemeral mount points, and run user-provided scripts.
 .
 Various methods are supported for passing data to the instance at launch
 time, including the standard interfaces of multiple platforms.

=== debian/rules ===
#!/usr/bin/make -f

PYTHON3S:=$(shell py3versions -vr)
export PYBUILD_INSTALL_ARGS=--init-system=systemd,sysvinit_deb

%:
	dh $@ --with python3 --buildsystem pybuild

override_dh_auto_test:
	set -e && set -x && for pyvers in $(PYTHON3S); do \
		PYMAJOR=`echo $$pyvers | cut -d'.' -f1` ; \
		echo "===> Testing with python$$pyvers (python$$PYMAJOR)" ; \
		PYTHON=python$$pyvers PYTHONPATH=. python$$pyvers -m pytest -v tests/unittests --ignore-glob $(CURDIR)/tests/unittests/test_datasource/test_opennebula.py ; \
	done

override_dh_installinit:
	dh_installinit --onlyscripts --no-start --no-stop-on-upgrade --name cloud-init-local
	dh_installinit --onlyscripts --no-start --no-stop-on-upgrade
	dh_installinit --onlyscripts --no-start --no-stop-on-upgrade --name cloud-config
	dh_installinit --onlyscripts --no-start --no-stop-on-upgrade --name cloud-final

override_dh_installsystemd:
	dh_installsystemd --no-restart-on-upgrade --no-start

override_dh_auto_clean:
	rm -rf .pybuild

## cloud-init 24.1.3

=== debian/changelog ===
cloud-init (24.1.3-0ubuntu3) noble; urgency=medium

  * cherry-pick 516fad6d: fix(url_helper): fix TCP connection leak on
    readurl() retries

 -- Brett Holman <brett.holman@canonical.com>  Fri, 05 Apr 2024 17:18:48 -0600

cloud-init (24.1.3-0ubuntu2) noble; urgency=medium

  * Upstream bug fix release based on 24.1.4.
    + functional fixes in debian/patches:
      - cpick-f74b61ea-ephemeral-dhcpcd-Set-dhcpcd-interface-down
        When dhcpcd client sets up a device to discover IMDS, ensure
        link is set back down to avoid interface rename failures (GH-5019)
      - cpick-372e80f8-net-dhcp-bump-dhcpcd-timeout-to-300s-5127
        Extend default timeout of dhcpcd command to 300 seconds
      - cpick-77771023-net-dhcp-raise-InvalidDHCPLeaseFileError-on-error
        Raise any dhcpcd lease parse failures as InvalidDHCPLeaseFileError
        (GH-5128)
      - cpick-f6ac6ee8-fix-dhcpcd-Make-lease-parsing-more-robust-5129
        Avoid tracebacks on empty invalid lease content from dhcpcd
        and raise InvalidDHCPLeaseFileError with full lease parsed when errors
        occur. (GH-5128)
    + test fixes in debian/patches:
      - d/p/cpick-accdfe6a-refactor-Import-log-module-rather-than-functions-5074
        Avoid mock failures in unit tests by module-level import of log
      - cpick-144782a8-test-Remove-side-effects-from-tests-5074

 -- Chad Smith <chad.smith@canonical.com>  Wed, 03 Apr 2024 12:26:52 -0600

cloud-init (24.1.3-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on 24.1.3.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.1.3/ChangeLog

 -- James Falcon <james.falcon@canonical.com>  Wed, 27 Mar 2024 08:27:29 -0500

cloud-init (24.1.2-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on 24.1.2.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.1.2/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2057763)

 -- Chad Smith <chad.smith@canonical.com>  Thu, 21 Mar 2024 07:53:15 -0600

cloud-init (24.1.1-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on 24.1.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.1.1/ChangeLog
    - Bugs fixed in this snapshot: (LP: #2056439, #2056460, #2055077)
      (LP: #2056194)

 -- Brett Holman <brett.holman@canonical.com>  Mon, 11 Mar 2024 21:09:37 -0600

cloud-init (24.1-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on 24.1.
    List of changes from upstream can be found at
    https://raw.githubusercontent.com/canonical/cloud-init/24.1/ChangeLog

 -- Brett Holman <brett.holman@canonical.com>  Thu, 29 Feb 2024 19:57:05 -0700

cloud-init (24.1~7g54599148-0ubuntu1) noble; urgency=medium

  * d/cloud-init.templates: enable WSL datasource by default.
  * Restore upstream ChangeLog without any merges.
    We have been merging an upstream ChangeLog spelling difference
    downstream for no good reason.
  * Upstream snapshot based on upstream/main at 54599148.
    - Bugs fixed in this snapshot: (LP: #2055081, #2055219)

 -- James Falcon <james.falcon@canonical.com>  Tue, 27 Feb 2024 17:42:55 -0600

cloud-init (24.1~6ga4140119-0ubuntu1) noble; urgency=medium

  * d/control: Replace isc-dhcp-client with dhcpcd-base
  * d/p/do-not-block-user-login.patch:
    - Remove patch, snapd no longer blocks ssh
  * d/s/: Move apport hook to main branch
  * d/cloud-init.postinst: change priority of hotplug rules.
    Avoids LP: #1946003 on upgraded systems. References:
    [0] https://github.com/canonical/cloud-init/pull/4799
    [1] commit/b519d861aff8b44a0610c176cb34adcbe28df144
  * Upstream snapshot based on upstream/main at a4140119.

 -- Brett Holman <brett.holman@canonical.com>  Fri, 16 Feb 2024 08:18:39 -0500

cloud-init (24.1~5g1f6eddd5-0ubuntu1) noble; urgency=medium

  * Upstream snapshot based on upstream/main at 1f6eddd5.
    - Bugs fixed in this snapshot: (LP: #2046483)

 -- Chad Smith <chad.smith@canonical.com>  Fri, 02 Feb 2024 14:39:53 -0700

cloud-init (24.1~4gd9677655-0ubuntu1) noble; urgency=medium

  * d/cloud-init.maintscript: remove /etc/cloud/clean.d/README
  * d/cloud-init.logrotate: add logrotate config for cloud-init
  * Upstream snapshot based on upstream/main at d9677655.
    - Bugs fixed in this snapshot: (LP: #2051147)

 -- Alberto Contreras <alberto.contreras@canonical.com>  Wed, 24 Jan 2024 18:45:19 +0100

=== debian/control ===
Source: cloud-init
Section: admin
Priority: optional
Homepage: https://cloud-init.io/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               iproute2,
               po-debconf,
               python3,
               python3-configobj,
               python3-debconf,
               python3-jinja2,
               python3-jsonpatch,
               python3-jsonschema,
               python3-mock,
               python3-netifaces,
               python3-oauthlib,
               python3-pytest,
               python3-pytest-mock,
               python3-requests,
               python3-serial,
               python3-setuptools,
               python3-yaml,
               python3-responses,
               python3-passlib
Vcs-Browser: https://github.com/canonical/cloud-init/tree/ubuntu/devel
Vcs-Git: https://github.com/canonical/cloud-init -b ubuntu/devel
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: cloud-init
Architecture: all
Depends: cloud-guest-utils | cloud-utils,
         dhcpcd-base,
         iproute2,
         netplan.io,
         procps,
         python3,
         python3-debconf,
         python3-netifaces,
         python3-requests,
         python3-serial,
         ${misc:Depends},
         ${python3:Depends}
Recommends: eatmydata, gdisk, gnupg, python3-apt, software-properties-common
Suggests: openssh-server, ssh-import-id
Description: initialization and customization tool for cloud instances
 Cloud-init is the industry standard multi-distribution method for
 cross-platform cloud instance initialization. It is supported across all major
 public cloud providers, provisioning systems for private cloud infrastructure,
 and bare-metal installations.
 .
 Cloud instances are initialized from a disk image and instance data:
 .
  * Cloud metadata
  * User data (optional)
  * Vendor data (optional)
 .
 Cloud-init will identify the cloud it is running on during boot, read any
 provided metadata from the cloud and initialize the system accordingly. This
 may involve setting up the network and storage devices to configuring SSH
 access key and many other aspects of a system. Later on the cloud-init will
 also parse and process any optional user or vendor data that was passed to
 the instance.

## cloud-init 24.1.6

=== debian/changelog ===
cloud-init (24.1.6-1) unstable; urgency=medium

  * New upstream version 24.1.6
  * Revert "Disable broken upstream test", as the upstream issue is resolved

 -- Noah Meyerhans <noahm@debian.org>  Fri, 24 May 2024 10:26:56 -0700

cloud-init (24.1.4-2) unstable; urgency=medium

  * Disable broken upstream test (Closes: #1069800)
  * Remove obsolete python3-mock builddep (Closes: #1066802)
  * Prefer udhcpc as the DHCP client for pre-network boot configuration
    (Closes: #1051421)
  * dh/rules: remove more artifacts during clean

 -- Noah Meyerhans <noahm@debian.org>  Thu, 25 Apr 2024 11:37:10 -0700

cloud-init (24.1.4-1) unstable; urgency=medium

  * New upstream version 24.1.4

 -- Noah Meyerhans <noahm@debian.org>  Wed, 24 Apr 2024 17:29:54 -0700

cloud-init (24.1.3-1) unstable; urgency=medium

  * New upstream version 24.1.3

 -- Noah Meyerhans <noahm@debian.org>  Wed, 27 Mar 2024 09:47:28 -0700

cloud-init (24.1.1-2) unstable; urgency=medium

  * Add passwd to Build-Depends (Closes: #1057548)

 -- Noah Meyerhans <noahm@debian.org>  Mon, 25 Mar 2024 14:12:56 -0700

=== debian/control ===
Source: cloud-init
Maintainer: Debian Cloud Team <debian-cloud@lists.debian.org>
Uploaders:
 Bastian Blank <waldi@debian.org>,
 Thomas Goirand <zigo@debian.org>,
 Noah Meyerhans <noahm@debian.org>,
Section: admin
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 iproute2,
 passwd,
 po-debconf,
 procps <!nocheck>,
 pylint,
 python3-all,
 python3-pep8,
 python3-setuptools,
Build-Depends-Indep:
 python3-configobj,
 python3-httpretty (>= 0.9.5),
 python3-jinja2,
 python3-jsonpatch,
 python3-jsonschema,
 python3-netifaces,
 python3-oauthlib,
 python3-passlib,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-mock,
 python3-requests,
 python3-responses,
 python3-serial,
 python3-yaml,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-init
Vcs-Git: https://salsa.debian.org/cloud-team/cloud-init.git
Homepage: https://launchpad.net/cloud-init

Package: cloud-init
Architecture: all
Conflicts: firewalld
Depends:
 eject,
 fdisk | util-linux (<< 2.29.2-3~),
 gdisk,
 udhcpc | isc-dhcp-client,
 locales,
 lsb-release,
 procps,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 cloud-guest-utils,
 eatmydata,
 sudo,
Suggests:
 btrfs-progs,
 e2fsprogs,
 xfsprogs,
Description: initialization system for infrastructure cloud instances
 Cloud-init provides a framework and tool to configure and customize virtual
 machine instances for Infrastructure-as-a-Service (IaaS) clouds platforms. It
 can for example set a default locale and hostname, generate SSH private host
 keys, install SSH public keys for logging into a default account, set up
 ephemeral mount points, and run user-provided scripts.
 .
 Various methods are supported for passing data to the instance at launch
 time, including the standard interfaces of multiple platforms.
